<?php

namespace FiloBlu\Core\Framework\Model\Mail\Template;

class TransportBuilder extends \Magento\Framework\Mail\Template\TransportBuilder
{
    protected $storeId = 0;

    public function getTransport()
    {
        try {
            $this->setStoreId();
            $this->prepareMessage();
            $mailTransport = $this->mailTransportFactory->create(['message' => clone $this->message, 'storeId' => $this->storeId]);
        } finally {
            $this->reset();
        }

        return $mailTransport;
    }

    public function setStoreId()
    {
        if (!isset($this->templateVars['rma']) || !isset($this->templateVars['rma_data'])) {
            return 0;
        }

        $this->storeId = (int)$this->templateOptions['store'];
    }

    public function getStoreId()
    {
        return $this->storeId;
    }
}
